/***************************************************************************
 *   Copyright (C) 2003 by Graham Morrison                                 *
 *   kalbum@paldandy.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include <ktextbrowser.h> 
#include <qstring.h>
#include <qstringlist.h>

#include "photodetailsexif.h"

PhotoDetailsExif::PhotoDetailsExif(QWidget *parent, const char *name)
 : PhotoExifDlg(parent, name)
{

	
}


PhotoDetailsExif::~PhotoDetailsExif()
{
}

// SLOT called when the image selection has changed.
// this implies the need to update the EXIF data.
void PhotoDetailsExif::slotSelectionChanged(QPtrList <PhotoAlbum> photolist) {

    m_photo = photolist;

    updateImageInfo();

}

// Update EXIF data depending on how many images are selected
void PhotoDetailsExif::updateImageInfo() {

    if (m_photo.count() == 0) {
        disableFields();
    } else if (m_photo.count() == 1) {
        enableFields();
        updateSingleImage();
    } else if (m_photo.count() > 1) {
        enableFields();
        updateMultipleImage();
    }

}

// Disable the window's fields (called when no images are selected)
void PhotoDetailsExif::disableFields() {

	KTextBrowser1->clear();

}

// Enables the window's fields 
void PhotoDetailsExif::enableFields() {

	KTextBrowser1->clear();

}

// Update EXIF data for a single selected image
void PhotoDetailsExif::updateSingleImage() {

	QString exif_key, html_text;

	QStringList::const_iterator it_data=m_photo.first()->exif.item_list.begin();

	html_text = "<table width=\"100%\" border=\"0\"><caption></caption><tbody>";
	
	for (QStringList::const_iterator it=m_photo.first()->exif.key_list.begin(); it!=m_photo.first()->exif.key_list.end(); ++it) {

		html_text+="<tr><td><b>";
		html_text+=*it;
		html_text+="</b></td><td>";
		html_text+=*it_data++;
		html_text+="</td></tr>";
		
	}
	
	html_text+="</tbody></table>";
	KTextBrowser1->setText(html_text);
}

// Update EXIF data for multiple selected images.
void PhotoDetailsExif::updateMultipleImage() {

}


#include "photodetailsexif.moc"
