/***************************************************************************
 *   Copyright (C) 2003 by Graham Morrison                                 *
 *   kalbum@paldandy.com                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef PHOTODETAILSEXIF_H
#define PHOTODETAILSEXIF_H

#include <qptrlist.h>

#include "photoexifdlg.h"
#include "photoalbum.h"

/**
This dialog displays the various exif meta fields available with an image.

@author Graham Morrison
*/
class PhotoDetailsExif : public PhotoExifDlg
{
Q_OBJECT
public:
    PhotoDetailsExif(QWidget *parent = 0, const char *name = 0);

    ~PhotoDetailsExif();

public slots:
  void slotSelectionChanged(QPtrList <PhotoAlbum> photolist);
	
private:
  QPtrList<PhotoAlbum> m_photo;
  void updateImageInfo();
  void updateSingleImage();
  void updateMultipleImage();
  void disableFields();
  void enableFields();

};

#endif
