/***************************************************************************
 *   Copyright (C) 2003 by Graham Morrison                                 *
 *   kalbum@paldandy.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include <qvariant.h>
#include <qstringlist.h>

#include "photoexif.h"

PhotoExif::PhotoExif() {}


PhotoExif::~PhotoExif() {}

void PhotoExif::Data(KFileMetaInfo info) {
    QVariant v;
    QString exif_key;

    comment = info.item("Comment").string();

    v = info.item("CreationDate").value();
    creation_date = v.asDate();

    v = info.item("CreationTime").value();
    creation_time = v.asTime();

    v = info.item("Date/Time").value();
    date_time = v.asDateTime();

    v = info.item("Dimensions").value();
    dimensions = v.asSize();

    v = info.item("Orientation").value();
    orientation = v.asInt();

    v = info.item("Flash Used").value();
    flash = v.asBool();

    v = info.item("Thumbnail").value();
    thumbnail = v.asImage();
    
    focal = info.item("Focal Length").string();

    jpeg_quality = info.item("JPEG quality").string();
    
    
    
    key_list = info.supportedKeys();
    
    for (QStringList::const_iterator it=key_list.begin(); it!=key_list.end(); ++it) {

	exif_key = *it;
	item_list += info.item(*it).string();
	
    }
    

}

