/***************************************************************************
 *   Copyright (C) 2003 by Graham Morrison                                 *
 *   kalbum@paldandy.com                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef PHOTOEXIF_H
#define PHOTOEXIF_H

#include <qstring.h>
#include <qstrlist.h> 
#include <qdatetime.h>
#include <qsize.h>
#include <qimage.h>
#include <kfilemetainfo.h>

/**
Provides information from the EXIF headers in the original image.

@author Graham Morrison
*/
class PhotoExif{
public:
    PhotoExif();

    ~PhotoExif();

    void		Data(KFileMetaInfo info);

    QString		comment;
    QDate 		creation_date;
    QTime 		creation_time;
    QDateTime		date_time;
    QSize		dimensions;
    int			orientation;
    bool		flash;
    QString		focal;
    QString		jpeg_quality;
    QImage		thumbnail;
    QStringList		key_list, item_list;


};

#endif
